prompt drop test table if it already exists
declare
  e_missing_table   exception;
  pragma exception_init (e_missing_table,-942);
begin
  execute immediate 'drop table ero_test_merge_bug';
exception
  when e_missing_table
  then
    null;
end;
/

prompt Create test table
create table ero_test_merge_bug
             (id not null
             ,value not null
             )
as select level
   ,      1
   from dual
   connect by level <= 10;


prompt List data in test table
select * 
from   ero_test_merge_bug;

prompt Declare a bind variable
variable my_id number

prompt Assign value to bind variable
exec :my_id := 3

prompt Display value of bind variable
select :my_id    bind_variable
from   dual;

prompt Execute merge statement with plsql and bind variable
prompt Will take some time to finally report: 
merge /*+ with_plsql */
into  ero_test_merge_bug  tgt
using (with
         function f (p in integer)
           return integer
           is
           begin
             return p * 10;
           end;
         --
         select id
         ,      f (id)  value
         from   ero_test_merge_bug
         where  id = :my_id
      ) src
on    (tgt.id = src.id)
when matched
then
  update set tgt.value = src.value
when not matched
then
  insert values (src.id, src.value)
/


-- need to reconnect now due to bug
prompt reconnect 
connect

prompt Cleanup: drop test table
drop table ero_test_merge_bug;

