prompt Readconsistency in a query
prompt No matter how long the query runs, the first and last record
prompt will show the same system_timestamp

with
  timestamp_query as
    (select systimestamp
     from   dual
    )
--
select level                                        row_id
,      (select systimestamp from timestamp_query)   now
from   dual
connect by level <= 10
;

prompt plsql in with clause *not* part of read consistency
prompt Each row will get the data that is current at the time
prompt the row is processed

with
  function timestamp_data
    return timestamp with time zone
    is
      l_result  timestamp with time zone;
    begin
      -- this doesn't need to be a query, but just so we do
      -- as much as possible the same as in the other query
      select systimestamp
      into   l_result
      from   dual;
      --
      return l_result;
    end;
--
select level                row_id
,      timestamp_data       now
from   dual
connect by level <= 10
/

